<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Banners</title>
    <style>
      body {
        box-sizing: border-box;
      }
      .image-to-show {
        width: 400px;
        height: 400px;
      }

      .images-wrapper {
        margin: auto;
        width: 400px;
        display: flex;
        flex-wrap: wrap;
        justify-content: space-between;
      }
      .hidden {
        display: none;
      }
      .buttons-wrapper {
        margin: auto;
        margin-top: 10px;
        width: 400px;
        display: flex;
        justify-content: center;
      }
      .stop {
        background-color: red;
        margin-right: 10px;
      }
      .start {
        background-color: green;
      }
    </style>
  </head>
  <body>
    <div class="images-wrapper">
      <img src="./img/1.jpg" alt="image of game" class="image-to-show" />
      <img src="./img/2.jpg" alt="image of game" class="image-to-show hidden" />
      <img src="./img/3.JPG" alt="image of game" class="image-to-show hidden" />
      <img src="./img/4.png" alt="image of game" class="image-to-show hidden" />
    </div>
    <div class="buttons-wrapper">
      <button class="btn stop">Прекратить</button>
      <button class="btn start">Возобновить показ</button>
    </div>

    <script>
      // 1. setTimeout позволяет вызвать функцию один раз через 
        //  определенное время, а setInterval - регулярно.

      // 2. Если в setTimeout() передать нулевую задержку, то
      // она вызовет функцию в setTimeout() настолько быстро, насколько
      // это возможно, но только после завершения выполнения текущего кода

      // 3. Потому что функции setInterval/setTimeout и их внешнее лексическое окружение
      // остается в памяти до тех пор, пока не будет вызван clearInterval().

  


            const imagesList = document.querySelectorAll(".images-wrapper img");
            let currentImg = 0;
            let timer;
            if (timer) clearInterval(timer);

            function createShowSlide() {
              timer = setInterval(() => {
                if (currentImg === imagesList.length) {
                  currentImg = 0;
                }
                imagesList[currentImg].classList.remove("hidden");

                if (currentImg === 0) {
                  imagesList[imagesList.length - 1].classList.add("hidden");
                } else {
                  imagesList[currentImg - 1].classList.add("hidden");
                }

                currentImg++;
              }, 3000);
            }
            createShowSlide();

            const buttons = document.querySelector(".buttons-wrapper");

            buttons.addEventListener("click", (e) => {
              if (e.target.classList.contains("stop")) clearInterval(timer);

              if (e.target.classList.contains("start")) createShowSlide();
            });
    </script>
  </body>
</html>
